let Element = require('./Element');
let Drawing = require('./Drawing');

class Rectangle extends Element {

	constructor(options) {
		super();

		//If no options parameter exists, just create a default rectangle.
		this.x           = 0;
		this.y           = 0;
		this.size        = {width: 10, height: 10};
		this.fillStyle   = 'black';
		this.strokeStyle = null;

		//Is there even an options parameter?
		if(options === undefined) {
			return;
		}

		//Does the Size option exist, and how?
		if(options.size) {
			if(options.size.width) {
				this.width = options.size.width
			}
			if(options.size.height) {
				this.height = options.size.height
			}
		}
	}

	draw(drawing) {
		if(!(drawing instanceof Drawing)) {
			return new TypeError('Draw function of a Rectangle was called without providing a proper drawing.');
		}

		drawing.context.rect(this.x, this.y, this.size.width, this.size.height);
		drawing.context.fillStyle   = this.fillStyle;
		drawing.context.strokeStyle = this.strokeStyle;
		drawing.context.fill();
		drawing.context.stroke();
		super.draw(drawing);
	}
}

module.exports = Rectangle;